#ifndef __FLC_H
#define __FLC_H

// ந뢠 䠩 FLI/FLC/CEL. ᨬ .. 1997/01-1998/03
// root@anis.velcom.vyatka.su
// 쪮  Large 
//  : bcc -ml flcvesa.c video.c

typedef unsigned char byte;
typedef unsigned int word;

#define ID_FLI          0xAF11
#define ID_FLC          0xAF12
#define ID_FRAME	0xF1FA
#define ID_FRAME_FLC    0xF100

typedef struct {
        long len;       //  䠩
        word id;        // 䨪 ID_FLI/ID_FLC
        word frames;    // ᫮ ३, ᨬ 4000
        word w;         // ਭ ࠭ = 320 ( FLI )
        word h;         //  ࠭ = 200 ( FLI )
        word bit;       //   ᥫ = 8
        word flags;     // 䫠 = 0x0003
        long delay;     // প  ३
			//  FLI - 1/70 ᥪ
			//  FLC - 1/1000 ᥪ
	word res;	// १
	//  ⮫쪮  FLC:
	long created;	//  ᮧ 䠩
	long creator;	// ਩  ணࠬ ᮧ襩 䠩
	long updated;	//  ᫥  䠩
	long updater;	// ਩  ணࠬ 襩 䠩
	word aspectx;	// . ய樮쭮  X 
	word aspecty;	// . ய樮쭮  Y 
	byte res1[38];	// १ = 0
        long first;	// ᬥ饭  砫 䠩   ३
        long second;	// ᬥ饭  砫 䠩  ன ३
        byte res2[40];	// १ = 0
} FLI_Header;


typedef struct {
	long len;
	word id;
	word parts;
	byte res[8];
} FLI_Frame;

typedef struct {
	long size;
	word type;
} FLI_Part;

typedef struct {
	FLI_Header fli_hd;
	FILE * f;
	long frame_ptr;
	char far * buf;
	byte id;	// 0 - , FLI -1, FLC-2
	byte all;	// 0 - ३  ⠭, 1 - ⠭ 
} FLC_file;

#define FLI_PALLETE	0xB
#define FLI_CHANGE	0xC
#define FLI_BLACK	0xD
#define FLI_ALL_LINE	0xF
#define FLI_IMAGE	0x10

#define FLI_DELTA	0x7
#define FLI_256_COLOR	0x4
#define FLI_MINI	0x12


//#define SIZE_BUF_FLI	64006UL

#ifdef __cplusplus
extern "C" {
#endif

void	flcOpen
	( char * name, FLC_file * flc ); //  FLC/FLI

void	flcClose
	( FLC_file * flc ); //  FLC/FLI

int	flcViewFrame
	( FLC_file * flc ); // 뢥 ३  ࠭

void	flcFirstFrame
	( FLC_file * flc ); // ⠭   ३

#ifdef __cplusplus
}
#endif

///////////////// VIDEO \\\\\\\\\\\\\\\\\\

typedef struct
{
	char vesa[4];
	char ver1;
	char ver2;
	char * far name;
	char cap[4];
	int * far modes;
	int mem;
	char res[240];
} VESAinfo;

typedef struct
{
	word sup:1;
	word is:1;
	word bios:1;
	word color_mono:1;
	word grap_text:1;
	word attr_res:11;
	byte a_exists:1;
	byte a_read:1;
	byte a_write:1;
	byte a_res:5;
	byte b_exists:1;
	byte b_read:1;
	byte b_write:1;
	byte b_res:5;
	word gran_k;
	word size_k;
	word seg_a;
	word seg_b;
	word far * pos_win;
	word bytes_line;
	word width;
	word height;
	byte width_char;
	byte height_char;
	byte planes;
	byte bit_per_pixels;
	byte banks;
	byte model;
	byte bank_k;
	char res[230];
} VESAmodeInfo;

#define LEN_PAL_256  	768

// VESA MODE
#define MODE_TEXT		0x3
#define MODE_320_200_256	0x13
#define MODE_640_480_256	0x101
#define MODE_800_600_256	0x103
#define MODE_1024_768_256	0x105
#define MODE_1280_1024_256	0x107

extern char far * video;
extern char far * video_ptr;
extern struct REGPACK reg;
extern word w_video, h_video;

#ifdef __cplusplus
extern "C" {
#endif

void	vid_xy
	( word x, word y ); // ⠭ ⥪   ࠭

void	vid_shift
	( word skip ); // ᤢ ࠢ ⥪ 

void	vid_set
	( word val, word count); //   梥⮬

void	vid_cpy
	(char far * ptr, word count); // 뢥 ᪮쪮 ᥫ

void	vid_pallete
	( word bCol, word count, char far * ptr ); // 

int 	vid_mode
	( word mode ); // ⠭ ०

#ifdef __cplusplus
}
#endif

#endif

