#ifndef __FLC_H
#define __FLC_H

#include <conio.h>
#include <crt0.h>
#include <ctype.h>
#include <dos.h>
#include <dpmi.h>
#include <go32.h>
#include <math.h>
#include <mem.h>
#include <pc.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/movedata.h>
#include <sys/nearptr.h>
#include <time.h>

// ந뢠 䠩 FLI/FLC/CEL. ᨬ .. 1997/01
// root@anis.velcom.vyatka.su
//  : gcc -c flcvesa.c
// 		gcc -c video.c
// 		gcc -o flcvesa flcvesa.o video.o

typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned int dword;

#define ID_FLI          0xAF11
#define ID_FLC          0xAF12
#define ID_FRAME	0xF1FA
#define ID_FRAME_FLC    0xF100

typedef struct {
        long len __attribute__ ((packed));       //  䠩
        word id __attribute__ ((packed));        // 䨪 ID_FLI/ID_FLC
        word frames __attribute__ ((packed));    // ᫮ ३, ᨬ 4000
        word w __attribute__ ((packed));         // ਭ ࠭ = 320 ( FLI )
        word h __attribute__ ((packed));         //  ࠭ = 200 ( FLI )
        word bit __attribute__ ((packed));       //   ᥫ = 8
        word flags __attribute__ ((packed));     // 䫠 = 0x0003
        long delay __attribute__ ((packed));     // প  ३
			//  FLI - 1/70 ᥪ
			//  FLC - 1/1000 ᥪ
	word res __attribute__ ((packed));	// १
	//  ⮫쪮  FLC:
	long created __attribute__ ((packed));	//  ᮧ 䠩
	long creator __attribute__ ((packed));	// ਩  ணࠬ ᮧ襩 䠩
	long updated __attribute__ ((packed));	//  ᫥  䠩
	long updater __attribute__ ((packed));	// ਩  ணࠬ 襩 䠩
	word aspectx __attribute__ ((packed));	// . ய樮쭮  X 
	word aspecty __attribute__ ((packed));	// . ய樮쭮  Y 
	byte res1[38] __attribute__ ((packed));	// १ = 0
        long first __attribute__ ((packed));	// ᬥ饭  砫 䠩   ३
        long second __attribute__ ((packed));	// ᬥ饭  砫 䠩  ன ३
        byte res2[40] __attribute__ ((packed));	// १ = 0
} FLI_Header;


typedef struct {
	long len __attribute__ ((packed));
	word id __attribute__ ((packed));
	word parts __attribute__ ((packed));
	byte res[8] __attribute__ ((packed));
} FLI_Frame;

typedef struct {
	long size __attribute__ ((packed));
	word type __attribute__ ((packed));
} FLI_Part;

typedef struct {
	FLI_Header fli_hd __attribute__ ((packed));
	FILE * f __attribute__ ((packed));
	long frame_ptr __attribute__ ((packed));
	char * buf __attribute__ ((packed));
	byte id __attribute__ ((packed));	// 0 - , FLI -1, FLC-2
	byte all __attribute__ ((packed));	// 0 - ३  ⠭, 1 - ⠭ 
} FLC_file;

#define FLI_PALLETE	0xB
#define FLI_CHANGE	0xC
#define FLI_BLACK	0xD
#define FLI_ALL_LINE	0xF
#define FLI_IMAGE	0x10

#define FLI_DELTA	0x7
#define FLI_256_COLOR	0x4
#define FLI_MINI	0x12


#ifdef __cplusplus
extern "C" {
#endif

void	flcOpen
	( char * name, FLC_file * flc ); //  FLC/FLI

void	flcClose
	( FLC_file * flc ); //  FLC/FLI

short	flcViewFrame
	( FLC_file * flc ); // 뢥 ३  ࠭

void	flcFirstFrame
	( FLC_file * flc ); // ⠭   ३

#ifdef __cplusplus
}
#endif

///////////////// VIDEO \\\\\\\\\\\\\\\\\\

typedef struct
{
	char vesa[4] __attribute__ ((packed));
	char ver1 __attribute__ ((packed));
	char ver2 __attribute__ ((packed));
	dword name __attribute__ ((packed));
	char cap[4] __attribute__ ((packed));
	dword modes __attribute__ ((packed));
	short mem __attribute__ ((packed));
	char res[240] __attribute__ ((packed));
} VESAinfo;

typedef struct
{
	word sup:1 __attribute__ ((packed));
	word is:1 __attribute__ ((packed));
	word bios:1 __attribute__ ((packed));
	word color_mono:1 __attribute__ ((packed));
	word grap_text:1 __attribute__ ((packed));
	word attr_res:11 __attribute__ ((packed));
	byte a_exists:1 __attribute__ ((packed));
	byte a_read:1 __attribute__ ((packed));
	byte a_write:1 __attribute__ ((packed));
	byte a_res:5 __attribute__ ((packed));
	byte b_exists:1 __attribute__ ((packed));
	byte b_read:1 __attribute__ ((packed));
	byte b_write:1 __attribute__ ((packed));
	byte b_res:5 __attribute__ ((packed));
	word gran_k __attribute__ ((packed));
	word size_k __attribute__ ((packed));
	word seg_a __attribute__ ((packed));
	word seg_b __attribute__ ((packed));
	dword pos_win __attribute__ ((packed));
	word bytes_line __attribute__ ((packed));
	word width __attribute__ ((packed));
	word height __attribute__ ((packed));
	byte width_char __attribute__ ((packed));
	byte height_char __attribute__ ((packed));
	byte planes __attribute__ ((packed));
	byte bit_per_pixels __attribute__ ((packed));
	byte banks __attribute__ ((packed));
	byte model __attribute__ ((packed));
	byte bank_k __attribute__ ((packed));
	char res[230] __attribute__ ((packed));
} VESAmodeInfo;

#define LEN_PAL_256  	768

// VESA MODE
#define MODE_TEXT		0x3
#define MODE_320_200_256	0x13
#define MODE_640_480_256	0x101
#define MODE_800_600_256	0x103
#define MODE_1024_768_256	0x105
#define MODE_1280_1024_256	0x107

extern char * video;
extern char * video_ptr;
extern __dpmi_regs reg;
extern word w_video, h_video;

#ifdef __cplusplus
extern "C" {
#endif

void	vid_xy
	( word x, word y ); // ⠭ ⥪   ࠭

void	vid_shift
	( word skip ); // ᤢ ࠢ ⥪ 

void	vid_set
	( word val, word count); //   梥⮬

void	vid_cpy
	(char * ptr, word count); // 뢥 ᪮쪮 ᥫ

void	vid_pallete
	( word bCol, word count, char * ptr ); // 

short 	vid_mode
	( word mode ); // ⠭ ०

void    vid_put_buffer
        ( void ); // ᪮஢ 

#ifdef __cplusplus
}
#endif

#endif

