#include "flc.h"

char * video;
char * video_ptr;
__dpmi_regs reg;
word w_video=320, h_video=200;
extern word x_flc, y_flc, w_flc, h_flc; //    FLC
word vmode=MODE_TEXT;

VESAinfo vi;
VESAmodeInfo vmi;
word ptr_x=0, ptr_y=0;
word seg_w, off_w, gran64;
long size_win_bytes;
word bytes_line;

dword size_video_buffer=64000;
dword ptr_vid_mem=0xA0000;
dword num_banks, last_bank;

//////////////  VIDEO BUFFER \\\\\\\\\\\\\\\\\\\\

void	vid_xy
	( word x, word y ) // ⠭ ⥪   ࠭
{
video_ptr=video+w_video*y+x;
}

void	vid_shift
	( word skip ) // ᤢ ࠢ ⥪ 
{
video_ptr+=skip; // ᤢ
}

void	vid_set
	( word val, word count) //   梥⮬
{
memset(video_ptr,val,count);
}

void	vid_cpy
	(char * ptr, word count) // 뢥 ᪮쪮 ᥫ
{
memcpy(video_ptr,ptr,count);
}

//////////////  VIDEO BUFFER \\\\\\\\\\\\\\\\\\\\

//////////////  VIDEO 320x200x8 \\\\\\\\\\\\\\\\\\\\

void    vid_put_buffer320
        ( void )
{
_dosmemputl(video,size_video_buffer>>2,ptr_vid_mem);
}

//////////////  VIDEO 320x200x8 \\\\\\\\\\\\\\\\\\\\

//////////////  VIDEO VESA \\\\\\\\\\\\\\\\\\\\\\\\\

void    vid_put_bufferVESA
        ( void )
{
int i;
reg.x.ax=0x4F05;
reg.x.bx=0x0000;
reg.x.dx=0x0000;
for ( i=0; i<num_banks; i++)
{
 __dpmi_int(0x10, &reg);
 reg.x.ax=0x4F05;
 _dosmemputl(video+i*size_win_bytes,size_win_bytes>>2,ptr_vid_mem);
 reg.x.dx+=gran64;
}
if ( last_bank!=0 )
{
 reg.x.ax=0x4F05;
 __dpmi_int(0x10, &reg);
 _dosmemputl(video+i*size_win_bytes,last_bank>>2,ptr_vid_mem);
}
}

//////////////  VIDEO VESA \\\\\\\\\\\\\\\\\\\\\\\\\

//////////////  VIDEO ALL \\\\\\\\\\\\\\\\\\\\\\\\\

void	vid_pallete
	( word bCol, word count, char * ptr )
{
dosmemput(ptr, count*3, __tb);
reg.x.ax=0x1012;
reg.x.bx=bCol;
reg.x.cx=count;
reg.x.es=(__tb >>4 ) & 0xffff;
reg.x.dx=__tb & 0x0f;
__dpmi_int(0x10, &reg);
}

void    vid_put_buffer
        ( void )
{
switch ( vmode )
{
case MODE_320_200_256:
     vid_put_buffer320();
     break;
case MODE_640_480_256:
case MODE_800_600_256:
case MODE_1024_768_256:
case MODE_1280_1024_256:
     vid_put_bufferVESA();
     break;
}
}

short	vid_mode
	( word mode ) // ⠭ ०
{
switch ( mode )
{
case MODE_TEXT:
{
	reg.x.ax=0x3;
        __dpmi_int(0x10, &reg);
	vmode=mode;
        free(video);
	break;
}
case MODE_320_200_256:
{
        ptr_vid_mem=0xA0000;
        size_video_buffer=320*200;
        video=(char *)malloc(size_video_buffer);
        memset(video,0,size_video_buffer);
        video_ptr=video;
        if ( video==0 ) return -1;
	reg.x.ax=0x13;
        __dpmi_int(0x10, &reg);
	vmode=mode;
	break;
}
case MODE_640_480_256:
case MODE_800_600_256:
case MODE_1024_768_256:
case MODE_1280_1024_256:
// ஢ઠ VESA
reg.x.ax=0x4f00;
reg.x.es=(__tb >>4 ) & 0xffff;;
reg.x.di=__tb & 0x0f;
__dpmi_int(0x10, &reg);
if ( reg.x.ax != 0x4f ) return -1;
dosmemget(__tb,sizeof(vi),&vi);
// ⠭ ०
reg.x.ax=0x4f02;
reg.x.bx=mode;
__dpmi_int(0x10, &reg);
if ( reg.x.ax != 0x4f ) return -1;
// ᭮ ଠ  ०
reg.x.ax=0x4f01;
reg.x.cx=reg.x.bx;
reg.x.es=(__tb >>4 ) & 0xffff;;
reg.x.di=__tb & 0x0f;
__dpmi_int(0x10, &reg);
dosmemget(__tb,sizeof(vmi),&vmi);
if ( !((reg.x.ax == 0x4f) && (vmi.sup) && (vmi.a_exists)) )
	return -1;
// ७ ६
vmode=mode;
w_video=vmi.width; h_video=vmi.height; bytes_line=vmi.bytes_line;
size_win_bytes=vmi.size_k;
size_win_bytes*=1024l;
gran64=vmi.size_k/vmi.gran_k;
ptr_vid_mem=vmi.seg_a<<4;
size_video_buffer=w_video*h_video;
video=(char *)malloc(size_video_buffer);
memset(video,0,size_video_buffer);
video_ptr=video;
if ( video==0 ) return -1;
num_banks=size_video_buffer/size_win_bytes;
last_bank=size_video_buffer%size_win_bytes;
break;
}
return 0;
}
