#ifndef __FLC_H
#define __FLC_H

//   FLI/FLC/CEL.  .. 1997/01-1998/03
// root@anis.velcom.vyatka.su
// Visual C++ v4.0

#include <stdio.h>
#include "win_type.h"

#define ID_FLI          0xAF11
#define ID_FLC          0xAF12
#define ID_FRAME		0xF1FA
#define ID_FRAME_FLC    0xF100

#pragma pack(1)
typedef struct {
        long len;       //  
        word id;        //  ID_FLI/ID_FLC
        word frames;    //  ,  4000
        word w;         //   = 320 ( FLI )
        word h;         //   = 200 ( FLI )
        word bit;       //    = 8
        word flags;     //  = 0x0003
        long delay;     //   
			//  FLI - 1/70 
			//  FLC - 1/1000 
		word res;	// 
		//    FLC:
		long created;	//   
		long creator;	//     
		long updated;	//    
		long updater;	//     
		word aspectx;	// .   X 
		word aspecty;	// .   Y 
		byte res1[38];	//  = 0
        long first;	//       
        long second;	//       
        byte res2[40];	//  = 0
} FLI_Header;


#pragma pack(1)
typedef struct {
	long len;
	word id;
	word parts;
	byte res[8];
} FLI_Frame;

#pragma pack(1)
typedef struct {
	long size;
	word type;
} FLI_Part;

typedef struct {
	FLI_Header fli_hd;
	FILE * f;
	long frame_ptr;
	char * buf;
	byte id;	// 0 - , FLI -1, FLC-2
	byte all;	// 0 -   , 1 -  
} FLC_file;

#define FLI_PALLETE		0xB
#define FLI_CHANGE		0xC
#define FLI_BLACK		0xD
#define FLI_ALL_LINE	0xF
#define FLI_IMAGE		0x10

#define FLI_DELTA		0x7
#define FLI_256_COLOR	0x4
#define FLI_MINI		0x12


#ifdef __cplusplus
extern "C" {
#endif

void	flcOpen
	( char * name, FLC_file * flc ); //  FLC/FLI

void	flcClose
	( FLC_file * flc ); //  FLC/FLI

short int	flcViewFrame
	( FLC_file * flc ); //    

void	flcFirstFrame
	( FLC_file * flc ); //    

#ifdef __cplusplus
}
#endif


#endif

