#include <windows.h>
#include <ddraw.h>
#include "video.h"

extern HWND	hWndProg;

word vmode=MODE_TEXT;
char * video=NULL;
char * video_ptr=NULL;
word w_video=320, h_video=200;
dword size_video_buffer=64000;

LPDIRECTDRAW ddObj=NULL; //  Direct Draw
DDSURFACEDESC sd; // .   DD Surface
LPDIRECTDRAWSURFACE psf=NULL; //  
LPDIRECTDRAWPALETTE pal=NULL; // 
PALETTEENTRY palEntries[256];

////////////  VIDEO DIRECT DRAW \\\\\\\\\\\\\\\\\\

void    vid_put_buffer
        ( void )
{
HRESULT rc=0;
UINT ws, i;
char * surf, * vid;

memset(&sd,0,sizeof(DDSURFACEDESC));
sd.dwSize=sizeof(DDSURFACEDESC);
//  
while ( 1 )
{
	rc=IDirectDrawSurface_Lock(psf,NULL,&sd,DDLOCK_SURFACEMEMORYPTR,NULL);
	switch ( rc )
	{
	case DD_OK: break;
	case DDERR_SURFACELOST:
		IDirectDrawSurface_Restore(psf); continue;
	case DDERR_WASSTILLDRAWING:
		continue;
	default: return;
	}
	break;
}
//     
surf=(char*)sd.lpSurface; ws=sd.lPitch;
vid=video;
if ( ws!=w_video )
for ( i=0; i<h_video; i++ )
{
	memcpy(surf,vid,w_video);
	surf+=ws; vid+=w_video;
}
else
	memcpy(surf,vid,size_video_buffer);
// 
IDirectDraw_WaitForVerticalBlank(ddObj,DDWAITVB_BLOCKBEGIN,0);
//  
IDirectDrawSurface_Unlock(psf,NULL);
}

void	vid_palette
	( word bCol, word count, char * ptr ) //  
{
int i;
for ( i=0; i<count; i++ )
{
	palEntries[i].peRed=(BYTE)*ptr++;
	palEntries[i].peGreen=(BYTE)*ptr++;
	palEntries[i].peBlue=(BYTE)*ptr++;
	palEntries[i].peFlags=0;
}
IDirectDrawPalette_SetEntries(pal,0,bCol,count,palEntries);
}

short	vid_mode
	( word mode ) //  
{
HRESULT rc=0;
DDSCAPS caps;

if ( mode==vmode ) return 0;

switch ( mode )
{
case MODE_TEXT:
{
Err:
	vmode=MODE_TEXT;
	if ( video!=NULL )
		free(video);
	if ( pal!=NULL )
		IDirectDrawPalette_Release(pal);
	if ( psf!=NULL )
		IDirectDrawSurface_Release(psf);
	if ( ddObj!=NULL )
		IDirectDraw_Release(ddObj);
	video=pal=psf=ddObj=NULL;
	return (short)rc;
}
case MODE_320_200_256: w_video=320; h_video=200; break;
case MODE_640_480_256: w_video=640; h_video=480; break;
case MODE_800_600_256: w_video=800; h_video=600; break;
case MODE_1024_768_256: w_video=1024; h_video=768; break;
case MODE_1280_1024_256: w_video=1280; h_video=1024; break;
}
size_video_buffer=w_video*h_video;
video=(char *)malloc(size_video_buffer);
memset(video,0,size_video_buffer);
video_ptr=video;
if ( video==0 ) return -1;
vmode=mode;
//   DD
rc=DirectDrawCreate(NULL,(LPDIRECTDRAW FAR*)&ddObj,NULL);
if ( rc!=DD_OK ) { rc=-1; goto Err; }
//   
rc=IDirectDraw_SetCooperativeLevel(ddObj,hWndProg,DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT );
if ( rc!=DD_OK ) { rc=-1; goto Err; }
rc=IDirectDraw_SetDisplayMode(ddObj,w_video,h_video,8);
if ( rc!=DD_OK ) { rc=-1; goto Err; }
//  
memset(&sd,0,sizeof(DDSURFACEDESC));
sd.dwSize=sizeof(DDSURFACEDESC);
sd.dwFlags=DDSD_CAPS;
sd.ddsCaps.dwCaps=DDSCAPS_PRIMARYSURFACE;
rc=IDirectDraw_CreateSurface(ddObj,&sd,&psf,NULL);
if ( rc!=DD_OK ) { rc=-1; goto Err; }
if ( rc!=DD_OK ) { rc=-1; goto Err; }
memset(palEntries,0,sizeof(PALETTEENTRY)*256);
rc=IDirectDraw_CreatePalette(ddObj,DDPCAPS_8BIT | DDPCAPS_ALLOW256,
	palEntries,&pal,NULL);
if ( rc!=DD_OK ) { rc=-1; goto Err; }
rc=IDirectDrawSurface_SetPalette(psf,pal);
if ( rc!=DD_OK ) { rc=-1; goto Err; }
vid_put_buffer();
return 0;
}
