
#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <stdarg.h>
#include "resource.h"
#include "cns.h"

// IDR_APPMENU, IDR_APPACCEL, IDI_APPICON
HWND	hWndProg;
HINSTANCE	hInstProg;
HACCEL	hAccelProg;

HDC memdc;		//     
HBITMAP hbit;	//    
HBRUSH hbrush;	//      
DWORD Tid;		//  
HANDLE thCons;

static int max_x=0, max_y=0, skip_y=0, skip_x=0, x_cns=0, y_cns=0, code_exit=0;
static BOOL MouseVis=1, WorkMenu=1;

char FileName[MAX_PATH] = "";

//    
static int is_key=0;
static UINT virt_key=0;

//     
#define X_BEG 10
#define Y_BEG 10

BOOL	fOpenFileDialog
		( HWND hwnd );
/*
	//   

int	cns_main
	( void )
{
	cns_printf("    ");
	cns_getch();
	cns_printf("");
	return 0;
}
*/

		//   

void	CmdLine
		( LPSTR lpCmdLine )
{
int len;
	len=strlen(lpCmdLine);	
	if ( len==0 ) return;
	memcpy(FileName,lpCmdLine+1,len-2);
	FileName[len-2]=0;
	PostMessage(hWndProg,WM_COMMAND,(WPARAM)IDM_OPEN,(LPARAM)0);
}

		//  

void	switchCns
		( void )
{
	WorkMenu=MouseVis=TRUE;
	FileName[0]=0;
	SetWindowPos(hWndProg,HWND_TOP,
		CW_USEDEFAULT, CW_USEDEFAULT,
		GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN),
		SWP_DRAWFRAME | SWP_SHOWWINDOW );
}

		//  

void	sleep
		( int del )
{
	Sleep(del);
}

		//   

void	cns_exit
		( int error )
{
	switchCns();
	TerminateThread(thCons,error);
}

	//  

DWORD	ConsoleThread
	( LPVOID param )
{
	//   
	int rc=cns_main();
	switchCns();
	return rc;
}

		//  

void	StartMain
		( void )
{
	if ( cns_kbhit() ) cns_getch();
	thCons=CreateThread(NULL,0,
		(LPTHREAD_START_ROUTINE)ConsoleThread,
		(LPVOID)hWndProg,0,&Tid);
	WorkMenu=MouseVis=FALSE;
}
	
		//    

int		cns_printf
		( char * fmt, ... )
{
va_list argptr;
int cnt;
static char str[256];
RECT rt;

rt.left=x_cns; rt.top=y_cns;

va_start(argptr, fmt);
cnt = vsprintf(str, fmt, argptr);
va_end(argptr);
TextOut(memdc,x_cns,y_cns,str,strlen(str));
y_cns+=skip_y;

rt.right=x_cns+skip_y*cnt; rt.bottom=y_cns;
InvalidateRect(hWndProg,&rt,FALSE);

if ( y_cns>=max_y-skip_y )
{
	y_cns=Y_BEG;
	PatBlt(memdc,0,0,max_x,max_y,BLACKNESS);
	InvalidateRect(hWndProg,NULL,TRUE);
}

return cnt;
}

	//   

int		cns_kbhit
		( void )
{
	return is_key;
}

	//   

int	cns_getch
	( void )
{
	while ( cns_kbhit()==0 );
	is_key=0;
	return virt_key;
}

	//  

void WndUpKey
	(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
is_key=1; virt_key=vk;
}

	//  

void WndPaint
	( HWND hwnd )
{
	HDC hdc;
	PAINTSTRUCT ps;

	hdc=BeginPaint(hwnd,&ps);
	BitBlt(hdc,ps.rcPaint.left,ps.rcPaint.top,
		ps.rcPaint.right-ps.rcPaint.left+1,
		ps.rcPaint.bottom-ps.rcPaint.top+1,
		memdc,
		ps.rcPaint.left,ps.rcPaint.top,SRCCOPY);
	EndPaint(hwnd,&ps);
}

	//  

BOOL	WndCreate
		( HWND hWnd, LPCREATESTRUCT lpCrt )
{
	HDC hdc;
	TEXTMETRIC tm;

	max_x=GetSystemMetrics(SM_CXSCREEN);
	max_y=GetSystemMetrics(SM_CYSCREEN);

	hdc=GetDC(hWnd);
	memdc=CreateCompatibleDC(hdc);
	hbit=CreateCompatibleBitmap(hdc,max_x,max_y);
	SelectObject(memdc,hbit);
	hbrush=GetStockObject(BLACK_BRUSH);
	SelectObject(memdc,hbrush);
	PatBlt(memdc,0,0,max_x,max_y,PATCOPY);
	ReleaseDC(hWnd,hdc);

	SetTextColor(memdc,RGB(255,255,255));
	SetBkColor(memdc,RGB(0,0,0));
	GetTextMetrics(memdc,&tm);
	skip_y=tm.tmHeight+tm.tmExternalLeading;
	skip_x=tm.tmWeight;
	x_cns=X_BEG; y_cns=Y_BEG;

	return TRUE;
}

	//  

#pragma warning(disable: 4098)
BOOL	WndSetCursor
	(HWND hWnd, HWND hwndCursor, UINT codeHitTest, UINT msg)
{
static vis=1;
	if ( MouseVis==TRUE )
	{
		if ( vis==0 ) { ShowCursor(TRUE); vis=1; }
		SetCursor(LoadCursor( NULL, IDC_ARROW ));
	}
	else
	{
		if ( vis==1 ) { ShowCursor(FALSE); vis=0; }
		SetCursor(NULL);
	}
	return FORWARD_WM_SETCURSOR(hWnd, hwndCursor, codeHitTest, msg, DefWindowProc);
}

	// 

#pragma warning(disable: 4098)
void	WndDestroy
		( HWND hWnd )
{
	PostQuitMessage(0);
	return FORWARD_WM_DESTROY(hWnd,DefWindowProc);
}

	//  

#pragma warning(disable: 4098)
void	WndCommand
	( HWND hWnd, int id, HWND hwndCtl, UINT codeNotify )
{
	switch ( id )
	{
	case IDCANCEL :
	case IDOK :
		PostQuitMessage(0);
		break;
	case IDM_OPEN:
		if ( WorkMenu==FALSE ) break;
		if ( strlen(FileName)==0 )
			if ( fOpenFileDialog(hWnd)==0 ) break;
		StartMain();
		break;
	}
	return FORWARD_WM_COMMAND(hWnd,id, hwndCtl, codeNotify, DefWindowProc);
}

	//     

LRESULT WINAPI WndProc
	( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch ( msg )
	{
		HANDLE_MSG(hWnd,WM_CREATE,WndCreate);
		HANDLE_MSG(hWnd,WM_DESTROY,WndDestroy);
		HANDLE_MSG(hWnd,WM_PAINT,WndPaint);
		HANDLE_MSG(hWnd,WM_COMMAND,WndCommand);
		HANDLE_MSG(hWnd,WM_KEYUP,WndUpKey );
		HANDLE_MSG(hWnd,WM_SETCURSOR,WndSetCursor);
	default:
		return (DefWindowProc(hWnd,msg,wParam,lParam));
	}
}

	//  

static BOOL initProg
	( int nCmdShow )
{
    WNDCLASSEX wcl;

	memset(&wcl,0,sizeof(wcl));
	wcl.cbSize=sizeof(wcl);
	wcl.hInstance = hInstProg;
	wcl.lpszClassName = szProgName;
	wcl.lpfnWndProc = (WNDPROC)WndProc;
	wcl.hIcon = LoadImage ( hInstProg,
		MAKEINTRESOURCE(IDI_APPICON), IMAGE_ICON, 32, 32, 0 );
	wcl.hIconSm = LoadImage ( hInstProg,
		MAKEINTRESOURCE(IDI_APPICON), IMAGE_ICON, 16, 16, 0 );
	wcl.hCursor = LoadCursor ( NULL, IDC_ARROW );
	wcl.lpszMenuName = MAKEINTRESOURCE(IDR_APPMENU);;
	wcl.hbrBackground = (HBRUSH) GetStockObject ( WHITE_BRUSH );
	if ( !RegisterClassEx(&wcl) )
		if ( !RegisterClass((LPWNDCLASS)&wcl) )
			return FALSE;
	//     
	hWndProg = CreateWindow ( szProgName, szProgTitle,
        WS_VISIBLE | WS_POPUP | WS_CAPTION | WS_SYSMENU,
		CW_USEDEFAULT, CW_USEDEFAULT,
		GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN),
		NULL,NULL,hInstProg,NULL );
    if( !hWndProg )
        return FALSE;
    hAccelProg = LoadAccelerators(hInstProg, MAKEINTRESOURCE(IDR_APPACCEL));
    if ( !hAccelProg )
        return FALSE;
	ShowWindow(hWndProg,nCmdShow);
    UpdateWindow( hWndProg );
    return TRUE;
}

	//  

int PASCAL WinMain
	( HINSTANCE hInstance, HINSTANCE hPrevInstance,
	  LPSTR lpCmdLine, int nCmdShow )
{
    MSG     msg;

    hInstProg = hInstance;

    if( !initProg(nCmdShow) ) return FALSE;

	CmdLine(lpCmdLine);

	while ( GetMessage ( &msg, NULL, 0, 0 ) )
	{
		if ( TranslateAccelerator ( hWndProg, hAccelProg, &msg ) != 0 )
			continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

		//    

BOOL	fOpenFileDialog
		( HWND hwnd )
{
OPENFILENAME ofn;

memset(&ofn,0,sizeof(OPENFILENAME));
ofn.lStructSize = sizeof(OPENFILENAME);
ofn.hwndOwner = hwnd;
ofn.lpstrFile = FileName;
ofn.nMaxFile = MAX_PATH;
ofn.lpstrFilter = "  (*.fli,*.flc,*.cel)\0*.FLI;*.FLC;*.CEL\0 (*.*)\0*.*\0";
ofn.lpstrTitle = " ";
ofn.nFilterIndex = 1;
ofn.lpstrFileTitle = NULL;
ofn.nMaxFileTitle = 0;
ofn.lpstrInitialDir = NULL;
ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

return GetOpenFileName(&ofn);
 
}

